package org.siprop.android.overlay;

import java.util.ArrayList;

import android.graphics.drawable.Drawable;

import com.google.android.maps.ItemizedOverlay;

/**
 * ユーザの現在地表示用Overlay
 * 
 * @author hirotaka@siprop.org
 *
 */
public class UserItemizedOverlay extends ItemizedOverlay<UserOverlayItem> {

	private  ArrayList<UserOverlayItem> overLayItemList = new  ArrayList<UserOverlayItem>();  

	public UserItemizedOverlay(Drawable defaultMarker) {
		super(boundCenterBottom(defaultMarker));
		populate();
	}

	@Override
	public boolean onTap(int index) {
		if (overLayItemList.size() == 0) return false;
		return true;
	}

	@Override
	protected UserOverlayItem createItem(int i) {
		if (overLayItemList.size() == 0)  return null;
		return overLayItemList.get(i);
	}

	@Override
	public int size() {
		return overLayItemList.size();
	}

	public void clearOverlay() {
		overLayItemList.clear();
        populate();
	}
	
	public void addOverlay(UserOverlayItem userOverlayItem) {
		this.addOverlay(userOverlayItem);
	}
	
	public void addOverlay(UserOverlayItem userOverlayItem, Drawable drawable)  {
    	if (drawable != null)
    		userOverlayItem.setMarker(boundCenterBottom(drawable));
    	for (UserOverlayItem item : overLayItemList) {
    		if (item.getLocationInfo().getUserId() == 
    			userOverlayItem.getLocationInfo().getUserId()) {
    			overLayItemList.remove(item);
    			break;
    		}
    	}
    	overLayItemList.add(userOverlayItem);
        populate();
    }
}
